// http://pastebin.mozilla.org/248895
// http://pastebin.mozilla.org/249457

/**  removeWmButton( oBtn )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      oBtn -

 Returns:   Nothing
 Called by: 1.
 Purpose:   1.
**/
custombuttons.removeWmButton = function(oBtn) //{{{
{
  let button = ( oBtn )? oBtn : document.popupNode;
  if ( oBtn || this.confirmBox( cb2String.sOvrlyDelete.replace(/%s/gi, button.label ), cb2String.sOvrlyRemoveConfirm.replace(/%s/gi, button.label ), cb2String.sOvrlyDeleteButton, cb2String.sOvrlyCancelButton ) ) {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var enumerator = wm.getEnumerator(this.App.windowType);
    while(enumerator.hasMoreElements()) {
      var win = enumerator.getNext();
      if (this.App.windowType == null) {
        if (win.custombuttons.App.ovlPaletteId == CB2const.TOOLBAR_PALETTE_TB_MC)
                              win.custombuttons.removeButton(button,win);
      } // End if ( win.custombuttons.App. )
      else {
        win.custombuttons.removeButton(button,win);
      } // End else ( win.custombuttons.App. )
    } // End while
  }
}; //}}} End Method removeWmButton( oBtn )

/**  removeButton(  )
  Author Yan, George Dunham

  Args:
  Returns: Nothing
  Scope:   private
  Called:  By custombuttons context menu.
  Purpose: To remove the button from the gToolbox palette and
  its parent toolbar
  UPDATED: 10/31/2007 To stabilize toolbar decoration issues
**/
custombuttons.removeButton = function ( oBtn , browserInstance) //{{{
{
  let Cb = browserInstance.custombuttons;
  let button = browserInstance.document.getElementById(oBtn.id);
  let num=Cb.getNumber( button.id );
  let values=Cb.getButtonParameters2( num );
  // Remove the button from it's toolbar
  if ( button.mObj ) {
    button.mObj.deInit();
  } // End if ( button.mObj )
  var toolbar = button.parentNode;
  toolbar.removeChild(button);
  for (var j in Cb.gToolbox.palette.childNodes){
    var but=Cb.gToolbox.palette.childNodes[j];
    if (but.getAttribute("id") == button.id){
      Cb.gToolbox.palette.removeChild(but);
      break;
    }
  }
  // Clean up the button's toolbar entry in localstore.rdf
  var sReplF = button.id +",";   // Will get all but a last instance
  var sReplL = "," + button.id;  // Will get the last instance it that was true.
  // Reset the button's toolbar and make permanent
  Cb.commitTbChanges( toolbar, "", sReplF, sReplL );
  Cb.App.saveButtonsToProfile();
}; //}}} End Method removeButton(  )
/**  cloneButton(  )
  Author Yan, George Dunham

  Args:
  Returns: Nothing
  Scope:   private
  Called:  By custombuttons context menu.
  Purpose: To create a duplicate of the button and place it in the
           current toolbar to the right this button.
  UPDATED: 10/31/2007 To stabilize toolbar decoration issues
**/
custombuttons.cloneButton = function ( oBtn ) //{{{
{
  oBtn = oBtn || document.popupNode;
  let num = this.getNumber(oBtn.id);
  var oValues = this.getButtonParameters2(num);
  return this.setWmNewButtonParameters(oBtn, oValues, 0);
}; //}}} End Method cloneButton(  )

/**  addButton(  )
  Author Yan, George Dunham

  Args:
  Returns:   Nothing
  Scope:     private
  Called by: 1.Custom buttons context menu.
  Purpose:   1. Open the button editor in Add Button mode.
  TODO: Modify to open in a tab and or bottom panel.
**/
custombuttons.addButton = function (  ) //{{{
{
  this.aEditorWindows.push([this.aEditorWindows.length, 1, openDialog("chrome://custombuttons/content/edit.xul", "custombuttons-edit", "chrome,resizable,dependent,dialog=no",null)]);
}; //}}} End Method addButton(  )

/**  editButton(  )
  Author Yan, George Dunham

  Args:
  Returns:   Nothing
  Scope:     private
  Called by:
  Purpose:
**/
custombuttons.editButton = function ( btn ) //{{{
{

  //checked
  // var Button = ( btn )? btn : document.popupNode;
  var Button = btn || document.popupNode;
  var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                     .getService(Components.interfaces.nsIWindowWatcher);
  var em = ww.getWindowEnumerator();
  var index = 1, win = {};
  while (em.hasMoreElements()) { // Focus existing editor vs opening duplicate
    win = em.getNext();
    if(win.name == Button.id) {
      win.focus();
      return;
    }
      index++
  } // End while (em.hasMoreElements())
  // No existing editor for this button >> Open a new one.
  this.aEditorWindows.push([this.aEditorWindows.length, 0, openDialog("chrome://custombuttons/content/edit.xul", Button.id, "chrome, resizable, dialog=no", Button)]);
}; //}}} End Method editButton(  )

/**  createButton( num, values )
  Author George Dunham

  Args:      num - Button ID Number
             values - object containing the button data
  Returns:   oItem as a button object
  Scope:     private
  Called By:
  Purpose:   To construct a button object given an ID # & data object.

  NOTE:  This id where the tooltip type is determined.
  UPDATED: 8/27/2007 made tooltip number optional
**/
custombuttons.createButton = function ( num, values ) //{{{
{
  var oItem = document.createElement("toolbarbutton");
  oItem.className = "toolbarbutton-1 chromeclass-toolbar-additional";
  oItem.setAttribute("context","custombuttons-contextpopup");
  oItem.setAttribute("id","custombuttons-button"+num);
  oItem.setAttribute("label",values.name||"");
  if ( this.bToolTipId ) {
    oItem.setAttribute("tooltiptext",values.name + " "||"");
  }
  else {
    oItem.setAttribute("tooltiptext",num+":"+values.name+" "||num);
  } // End if ( !this.isPref( CB2const.BUTTON_TT_CB_ID) || this.getPrefs( CB2const.BUTTON_TT_CB_ID) )
  if ( values.image&&values.image.length != -1 ) oItem.setAttribute("image",values.image);
  var code = values.code||cb2String.sOvrlyCB2codeDefault;
  var initCode=values.initCode||cb2String.sOvrlyCB2icodeDefault;
  var Help=values.Help||"";
  oItem.setAttribute("cb-oncommand",code);
  oItem.setAttribute("cb-init",initCode);
  oItem.setAttribute("Help",Help);
  return oItem;
}; //}}} End Method createButton( num, values )

/**  installWebButton( uri )
  Author Yan, George Dunham

  Args:      uri
  Returns:   lRet
  Scope:     private
  Called by: 1. custombutton event listener
  Purpose:   1. Install a custom button link as a custombutton.
**/
custombuttons.installWebButton = function ( uri ) //{{{
{
  debugger
  var oValues = this.oSplitButtonURI(uri);
  if ( typeof oValues != CB2const.BOOLEAN ) {      // Success
    if (this.confirmBox( cb2String.sOvrlyInstall.replace(/%s/gi, oValues.name)
                        , cb2String.sOvrlyInstallConfirm.replace(/%s/gi, oValues.name)
                        , cb2String.sOvrlyInstallButton, cb2String.sOvrlyCancelButton )) {
      this.setWmNewButtonParameters(null, oValues, 1);
      var str=cb2String.sButtonAddedAlert
      var Ttl=cb2String.sButtonAddedTitle.replace(/%s/gi,oValues.name)
      this.alertBox(Ttl, str);
    } // End if ( if (this.Cb.confirmBox( cb2String.sOvrlyInstall.replace(/%s/gi, oValues.name), cb2String.sOvrlyInstallConfirm.replace(/%s/gi, oValues.name), cb2String.sOvrlyInstallButton, cb2String.sOvrlyCancelButton )) )
  } // End if ( typeof oValues != CB2const.BOOLEAN )
}; //}}} End Method installWebButton( uri )

/**  disableButton( btn, state )
  Author George Dunham

  Args:      btn
             state
  Returns:   Nothing
  Scope:     public
  Called by: 1. Any process which may optionally pass
                btn (button object) and state (boolean)
  Purpose:   1. Toggle a button's availability on/off
             2. The custom buttons context menu is always active.
**/
custombuttons.disableButton = function ( evt, btn, state ) //{{{
{
  if ( btn ) {
    btn.disabled = state;
    btn.initialized = !state;
    btn.style.opacity = ( !btn.disabled )? ".99" : ".3" ;
  }
  else {
    var oBtn = document.popupNode;
    oBtn.disabled = !oBtn.disabled;
    oBtn.initialized = !oBtn.initialized
    oBtn.style.opacity = ( !oBtn.disabled )? ".99" : ".3" ;
  }; // End if ( btn, state  )
}; //}}} End Method disableButton( btn, state )

/**  uCbuttonButes(  )
  Author Yan, George Dunham

  Args:
  Returns:   Nothing
  Scope:     private
  Called by: 1.Custom buttons context menu.
  Purpose:   1. Display the button's attributes in an alert
             2. Insert the data into the clipboard for pasting.

**/
custombuttons.uCbuttonButes = function ( oBtn ) //{{{
{
  // UPDATED: 11/8/2007 to accept oBtn as an arg.
  var Button = ( oBtn )? oBtn : document.popupNode;
  let pub = Button.getAttribute("public");
  pub = (pub == "true")? cb2String.sOvrlyCB2AtrPub : cb2String.sOvrlyCB2AtrPriv;
  let sPad = "";
  let sln = new Array(8)
  let slf ="\n\n";
  sln[0] = "\t\t"+cb2String.sOvrlyCB2sln0.replace(/%s/gi,Button.label).replace(/%y/gi,pub);
  sln[1] = cb2String.sOvrlyCB2sln1.replace(/%s/gi,Button.getAttribute("author"   ));
  sln[2] = cb2String.sOvrlyCB2sln2.replace(/%s/gi,Button.getAttribute("version"   ));
  sln[3] = cb2String.sOvrlyCB2sln3.replace(/%s/gi,Button.getAttribute("homepage"   ));
  sln[4] = cb2String.sOvrlyCB2sln4.replace(/%s/gi,Button.getAttribute("dependency"));
  sln[5] = cb2String.sOvrlyCB2sln5.replace(/%s/gi,Button.getAttribute("status"   ));
  let pad = this.uCstrpad(sln);
  for ( let i = 0 ; i < pad ; i++ ) {
    sPad += " ";
  }
  sln[0] = sPad + sln[0];
  sPad = "";
  for ( let i in sln) {
    sPad += sln[i] + slf;
  }
  if (Button.label == "userChrome Button") {
    sPad += "\n\t\t"+cb2String.sOvrlyCB2uCHlp;
  }
  gClipboard.write(sPad);
  let ButeMsg = createMsg( cb2String.sOvrlyButeMsg.replace(/%s/,Button.label) );
  ButeMsg.aMsg(gClipboard.read());
}; //}}} End Method uCbuttonButes(  )

/**  uChelpButton(  )
  Author Yan, George Dunham

  Args:
  Returns:   Nothing
  Scope:     private
  Called by: 1. Custom buttons context menu.
  Purpose:   1. Display the button's help text.
             2. Insert the help data into the clipboard.
  TODO:      Provide a means to display help in the form of
             web page.
**/
custombuttons.uChelpButton = function ( oBtn ) //{{{
{
  // UPDATED: 11/8/2007 to accept oBtn as an arg.
  var Button = ( oBtn )? oBtn : document.popupNode;
  var bId = this.getNumber(Button.id);
  var str = Button.getAttribute( "Help" ).split( "[,]" )[0] || Button.getAttribute( "help" ).split( "," )[1];

  if (!str) {str = cb2String.sOvrlyCB2buttonHelpstr;}
  var hlp = createMsg(cb2String.sOvrlyCB2buttonHelpLbl.replace(/%s/gi,Button.label).replace(/%y/gi,bId));
  gClipboard.write(str.replace(/\<label\>/gi,Button.label).replace(/\<id\>/gi,bId));
  hlp.aMsg(gClipboard.read());
}; //}}} End Method uChelpButton(  )

/**  saveThisButton(  )
  Author Yan, George Dunham

  Args:
  Returns: Nothing
  Scope:   private
  Called:  Via the button's context menu. Not intended to be called as a common
           routine.
  Purpose: Build the output stream which will be written to disk
           creating a Web document.
**/
custombuttons.saveThisButton = function ( oBtn ) //{{{
{
  // UPDATED: 11/8/2007 to accept oBtn as an arg.
  var oButton = ( oBtn )? oBtn : document.popupNode;
  var Cb2HomePg = cb2String.sOvrlyCB2Hpage
  var xstr = '\n<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"> \n';
  xstr += '<html xmlns="http://www.w3.org/1999/xhtml"> \n';
  // Start Header Here
  xstr += '<head> \n<style type="text/css">img{padding-right: 2mm}</style>';
  xstr += '<title>\n';
  var num = custombuttons.getNumber(oButton.id);
  var values = custombuttons.getButtonParameters2(num);
  xstr += cb2String.sOvrlyCB2savThsBtnCbFcbe.replace(/%s/gi,values.name).replace(/%y/gi,CB2const.sOvrlyCB2ExtName);
  xstr += '</title> \n';
  xstr += '</head> \n';
  // End Header - Start Body
  xstr += '<body style="background-color: #FFFFDF"\><center>\n';
  // Image div Block Start
  xstr += '<div id="waterMark"\><a href="'+Cb2HomePg+'"\><img alt='+cb2String.sOvrlyCB2savThsBtnWmImAlt+' src="' + this.Cb2Logo() + '" width=349 height=90 border = 0/></a\>\n</div\>\n';
  // Image div Block End - Display Name
  xstr += '<h1> <font size="+4" color="#800080"\>\n\n';
  xstr +=  values.name + '\n\n';
  xstr += '</font></h1>';
  // Display Button
  xstr += '<h3><font color="#800080">\n\n';
  this.createLinks(CB2const.nHyper);
  var link = gClipboard.read();
  xstr += link + '</font>';
  // Display Attributes
  xstr += '</h3><font color="#800080">\n';
  var xtmp = oButton.getAttribute('version');
  xstr += ( xtmp.length > 0 )? cb2String.sOvrlyCB2savThsBtnVersion.replace(/%s/gi,xtmp) : '<br />\n';
  xtmp =  oButton.getAttribute('author');
  xtmp = ( xtmp.length > 0 )? xtmp : cb2String.sOvrlyCB2savThsBtnAnonLine;
  xstr += cb2String.sOvrlyCB2savThsBtnAuthor.replace(/%s/gi,xtmp)+'<br /> \n';
  xtmp  = oButton.getAttribute('status');
  xstr += ( xtmp.length > 0 )? cb2String.sOvrlyCB2savThsBtnStatLine.replace(/%s/gi,xtmp) : '<br/><br/>\n';
  xtmp  = oButton.getAttribute('dependency');
  xstr += ( xtmp.length > 0 )? cb2String.sOvrlyCB2savThsBtnDepLine.replace(/%s/gi,xtmp) : '<br/><br/><br/>\n';
  xtmp  = oButton.getAttribute('homepage');
  xstr += '<b><a href=';
  xstr += ( xtmp.length > 0 )? xtmp + '>'+cb2String.sOvrlyCB2savThsBtnHomLine.replace(/%s/gi,values.name): cb2String.sOvrlyCB2savThsBtnHomLine1.replace(/%s/gi,Cb2HomePg);
  xstr += '</a></b><br/><br/><br/><br/><br/><br/></font>';
  // Display Credits
  xstr += '<font size="-1" color="#800080"\>'+cb2String.sOvrlyCB2savThsBtnProj.replace(/%s/gi,CB2const.sOvrlyCB2ExtName);
  xstr += '</font></center>\n';
  xstr += '</body>\n';
  xstr += '</html>\n';
  // Close Document - Fix up String
  xstr = xstr.replace(/>,</g,'><');
  custombuttons.BackupFile(xstr, values.name);
}; //}}} End Method saveThisButton(  )

/**  cpyButtonName(  )
  Author Yan, George Dunham

  Args:
  Returns: Nothing - Stuffs the clipboard with the data
  Scope:   private
  Called:  From the Custombuttons context menu.
  Purpose: Stuff the clipboard with the copy Button Name data
           and pop a msgBox with the data.
**/
custombuttons.cpyButtonName = function ( oBtn ) //{{{
{
  // UPDATED: 11/8/2007 to accept oBtn as an arg.
  var Button = ( oBtn )? oBtn : document.popupNode;
  var strstat = Button.getAttribute("status");
  strstat = (strstat.length > 0)? cb2String.sOvrlyCB2cpyButStat.replace(/%s/gi,strstat) : cb2String.sOvrlyCB2cpyButStatNSet;
  var strver = Button.getAttribute("version");
  strver = (strver.length > 0)? cb2String.sOvrlyCB2cpyButVer.replace(/%s/gi,strver) : cb2String.sOvrlyCB2cpyButVerNSet;
  var str = Button.label +" "+ strver +" "+ strstat;
  gClipboard.write(str);
  var cbn = createMsg(cb2String.sOvrlyCB2cpyButNamVer.replace(/%s/gi,Button.label));
  cbn.aMsg(gClipboard.read());
}; //}}} End Method cpyButtonName(  )
/**  updateButton(  )
  Author George Dunham

  Args:
  Returns: Nothing
  Scope:   private
  Called:  From the Custombuttons context menu.
  Purpose: Update an existing button with new field data.
**/
custombuttons.updateButton = function ( oBtn ) //{{{
{
  var bValue = this.oSplitButtonURI(gClipboard.read());
  let newPaletteBtn = {}, newTbBtn2 = {};
  if ( typeof bValue != CB2const.BOOLEAN ){        // Success
    var oButton = ( oBtn )? oBtn : document.popupNode;
    if ( oBtn || this.confirmBox( cb2String.sOvrlyUpdate.replace(/%s/gi, oButton.label ), cb2String.sOvrlyUpdateConfirm.replace(/%s/gi, oButton.label ).replace(/%y/gi, bValue.name ), cb2String.sOvrlyUpdateButton, cb2String.sOvrlyCancelButton ) ) {
      this.setWmNewButtonParameters(oButton, bValue, 2);
    } // End if ( this.confirmBox() )
  } // Endif ( typeof bValue != CB2const.BOOLEAN )
}; //}}} End Method updateButton(  )


/**  getPaletteMember( id )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      id -
 Returns:   oRet
 Called by: 1.
 Purpose:   1.

 */
custombuttons.getPaletteMember = function(id) //{{{
{
  let oRet = null;
  for (let j = 0;j<this.gToolbox.palette.childNodes.length;j++){
    if (this.gToolbox.palette.childNodes[j].getAttribute("id")==id){
      oRet = this.gToolbox.palette.childNodes[j];
      break;
    } // End if (this.gToolbox.palette.childNodes[j].getAttribute("id")=="custombuttons-button00")
  } // End for
  return oRet;
}; //}}} End Method getPaletteMember( id )
/**  getFirstCustomizableTb(  )
 Author:    George Dunham aka: SCClockDr
 Scope:     global
 Args:
 Returns:   oRet
 Called by: 1. Anyone
 Purpose:   1. Return a customizable toolbar in any App for default operations
 */
custombuttons.getFirstCustomizableTb = function() //{{{
{
  let aToolbars = this.getToolbars();
  for (var i = 0; i < aToolbars.length; ++i) {
    if (this.isCustomizableToolbar(aToolbars[i])) return aToolbars[i];
  } // End (var i = 0; i < aToolbars.length; ++i)
  return null;
}; //}}} End Method getFirstCustomizableTb(  )

/**  getFirstLiveButton(  )
 Author:    George Dunham aka: SCClockDr
 Scope:     global
 Args:
 Returns:   oBtn
 Called by: 1. setNewButtonParameters
 Purpose:   1. Find and Rturn a valid custombuttons id
 */
custombuttons.getFirstLiveButton = function() //{{{
{
  let oBtn = document.getElementById("custombuttons-button0"), forced = false;
  if (!oBtn) {
    let aToolbars = this.getToolbars(), aNodes = [];
    for (let i = 0; i < aToolbars.length; i++) {
      aNodes = aToolbars[i].childNodes;
      for (let j = 0; j < aNodes.length; j++) {
        if (/custombuttons-button/.test(aNodes[j].id.substr(0,20)) ) {
          if (aNodes[j].getAttribute("initialized") == "true" && !aNodes[j].hidden){
            if ( !aNodes[j].hasAttribute("disabled") || (aNodes[j].hasAttribute("disabled") && aNodes[j].getAttribute("disabled") == "false")) {
              oBtn = aNodes[j]
              break;
            } // End if ( (aNodes[j].hasAttribute("disabled") && aNodes[j].getAttribute("disabled") == "false") )
          } // End if (aNodes[j].getAttribute("initialized") == "true" && !aNodes[j].hidden)
        } // End if ( /custombuttons-button/.test(Nodes[j].id)  )
      } // End for (let j = 0; j < aNodes.length; j++)
    } // End for (let i = 0; i < aToolbars.length; i++)
    if (! oBtn) {
      let toolbar = this.getFirstCustomizableTb();
      let button = this.getPaletteMember("custombuttons-button0");
      oBtn = button.cloneNode(true);
      this.insertToToolbar(toolbar, oBtn, null);
      oBtn = document.getElementById("custombuttons-button0");
      forced = true;
    } // End if ( ! oBtn )
  } // End if ( !oBtn )
  return [oBtn, forced];
}; //}}} End Method getFirstLiveButton(  )

/**  setWmNewButtonParameters( oBtn, oValues, mode )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      oBtn -
            oValues -
            mode -
 Returns:   sRet
 Called by: 1.
 Purpose:   1.

**/
custombuttons.setWmNewButtonParameters = function(oBtn, oValues, mode) //{{{
{
  let sRet = null;
  let oBtnId = (oBtn == null)? null : oBtn.id;
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
  var enumerator = wm.getEnumerator(this.App.windowType);
  while(enumerator.hasMoreElements()) {
    var win = enumerator.getNext();
    if (this.App.windowType == null) {
      if (win.custombuttons.App.ovlPaletteId == CB2const.TOOLBAR_PALETTE_TB_MC)
                    sRet = win.custombuttons.setNewButtonParameters(oBtnId, oValues, mode, win);
    } // End if ( win.custombuttons.App. )
    else {
      sRet = win.custombuttons.setNewButtonParameters(oBtnId, oValues, mode, win);
    } // End else ( win.custombuttons.App. )
  } // End while
  return sRet;
}; //}}} End Method setWmNewButtonParameters( oBtn, oValues, mode )

/**  setNewButtonParameters( oBtn, oValues )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      oBtn -
            oValues -
 Returns:   Nothing
 Called by: 1.
 Purpose:   1.
 */
custombuttons.setNewButtonParameters = function(oBtnId, oValues, mode, browserInstance) //{{{
{
  let Cb = (browserInstance)? browserInstance.custombuttons : custombuttons;
  let oBtn = (browserInstance)? browserInstance.document.getElementById(oBtnId) : document.getElementById(oBtnId);
  let newPaletteBtn = {}, newTbBtn = {}, newTbBtn2 = {}, sibling = null;
  let toolBar = {}, newNum = Cb.min_button_number();
  let sDat, sTarg1, sTarg2, forced = false;
  sDat = sTarg1 = sTarg2 = "";
  if (!oBtn) {
    [oBtn, forced] = Cb.getFirstLiveButton();
  } // End if ( !oBtn )
  if (!oBtn && mode == 1) {
    alert("Please inform the author if you see this alert")
    Cb.App.setButtonParameters( null, values );
    return null;
  }
  // mode 0 == Clone
  // mode 1 == New Create/InstallWeb
  // mode 2 == update/Edit
  if (oBtn && oBtn.mObj) {
    oBtn.mObj.deInit();
  } // End if ( oBtn.mObj )
  newTbBtn2 = Cb.getPaletteMember(oBtn.id)
  newPaletteBtn = newTbBtn2.cloneNode(false);
  newPaletteBtn.hidden = false;
  for each (let j in Cb.buttonParameters) {
    switch (j)
    {
    case "name":
      newPaletteBtn.setAttribute("label", oValues[j]);
      break;
    case "image":
      newPaletteBtn.setAttribute("image", oValues[j]);
      break;
    case "code":
      newPaletteBtn.setAttribute("cb-oncommand", oValues[j]);
      break;
    case "initCode":
      newPaletteBtn.setAttribute("cb-init", oValues[j]);
      break;
    case "Help":
      newPaletteBtn.setAttribute("Help", oValues[j]);
      break;
    default :
      break;
    } // End switch ( j )
  } // End for
  let num = (mode > 1)? Cb.getNumber(oBtn.id) :  newNum;
  if (Cb.bToolTipId) {
    newPaletteBtn.setAttribute("tooltiptext",oValues.name + " "||"");
  }
  else {
    newPaletteBtn.setAttribute("tooltiptext",num+":"+oValues.name+" "||num);
  } // End if ( Cb.bToolTipId )
  newTbBtn = newPaletteBtn.cloneNode(true);
  switch (mode)
  {
  case 0:   //clone
    toolBar = oBtn.parentNode;
    newTbBtn.setAttribute("id", "custombuttons-button"+newNum);
    Cb.insertToToolbar( toolBar, newTbBtn, oBtn.nextSibling);
    Cb.commitTbChanges(toolBar, newTbBtn.id, oBtn.id);
    newPaletteBtn.setAttribute("id", "custombuttons-button"+newNum);
    Cb.gToolbox.palette.appendChild(newPaletteBtn);
    break;
  case 1:   //New Button
    toolBar = oBtn.parentNode;
    newTbBtn.setAttribute("id", "custombuttons-button"+newNum);
    let remButton = Cb.insertToToolbar( toolBar, newTbBtn, oBtn.nextSibling);
    newPaletteBtn.setAttribute("id", "custombuttons-button"+newNum);
    Cb.gToolbox.palette.appendChild(newPaletteBtn);
    toolBar.removeChild(remButton);
    if (forced) {
      let tempBt = document.getElementById("custombuttons-button0");
      let tempTb = tempBt.parentNode
      tempTb.removeChild(tempBt);
    } // End if ( forced )
    Cb.App.saveButtonsToProfile();
    return null;
    break;
  default : // Update Button
    [toolBar, oBtn] = Cb.findButtonOnBars(oBtn.id);
    toolBar.replaceChild(newTbBtn,oBtn);
    for (let j = 0;j<Cb.gToolbox.palette.childNodes.length;j++){
      if (Cb.gToolbox.palette.childNodes[j].getAttribute("id")==oBtn.id){
        Cb.gToolbox.palette.replaceChild(newPaletteBtn,Cb.gToolbox.palette.childNodes[j]);
        break;
      }
    }
    break;
  } // End switch ( method )
  Cb.App.saveButtonsToProfile();
  return newTbBtn.id
}; //}}} End Method setNewButtonParameters( oBtn, oValues )

/**  updateButtonParameters( oBtn, oValues )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      oBtn -
            oValues -
 Returns:   Nothing
 Called by: 1.
 Purpose:   1.
 */
custombuttons.updateButtonParameters = function(oBtn, oValues) //{{{
{
  let newPaletteBtn = {}, newTbBtn = {}, newTbBtn2 = {};
  let toolBar = oBtn.parentNode;
  if (oBtn.mObj) {
    oBtn.mObj.deInit();
  } // End if ( oButton.mObj )
  for (let j = 0;j<this.gToolbox.palette.childNodes.length;j++){
    if (this.gToolbox.palette.childNodes[j].getAttribute("id")==oBtn.id){
      newTbBtn2 = this.gToolbox.palette.childNodes[j];
      break;
    }
  }
  newPaletteBtn = newTbBtn2.cloneNode(false);
  for each (let j in this.buttonParameters) {
    switch (j)
    {
    case "name":
      newPaletteBtn.setAttribute("label", oValues[j]);
      break;
    case "image":
      newPaletteBtn.setAttribute("image", oValues[j]);
      break;
    case "code":
      newPaletteBtn.setAttribute("cb-oncommand", oValues[j]);
      break;
    case "initCode":
      newPaletteBtn.setAttribute("cb-init", oValues[j]);
      break;
    case "Help":
      newPaletteBtn.setAttribute("Help", oValues[j]);
      break;
    default :
      break;
    } // End switch ( j )
  } // End for
  newTbBtn = newPaletteBtn.cloneNode(true);
  toolBar.replaceChild(newTbBtn,oBtn);
  for (let j = 0;j<this.gToolbox.palette.childNodes.length;j++){
    if (this.gToolbox.palette.childNodes[j].getAttribute("id")==oBtn.id){
      this.gToolbox.palette.replaceChild(newPaletteBtn,this.gToolbox.palette.childNodes[j]);
      break;
    }
  }
  this.initializeButton(newTbBtn);
}; //}}} End Method updateButtonParameters( oBtn, oValues )


/**  bookmarkButton(  )
  Author George Dunham

  Args:
  Returns: Nothing
  Scope:   private
  Called:
  Purpose: Allows one to save a button as a bookmark
  UPDATED: 11/12/2007 to improve stability.
**/
custombuttons.bookmarkButton = function ( oBtn ) //{{{
{
  // UPDATED: 11/8/2007 to accept oBtn as an arg.
  var Button = ( oBtn )? oBtn : document.popupNode;
  this.createLinks( CB2const.nClipbrd, Button );
  // UPDATED: 10/10/2007 to accomodate Minefield Places
  // UPDATED: 2/1/2008   to incorporate Minefield into Apps
  this.App.makeBookmark(gClipboard.read(), Button.label);
}; //}}} End Method bookmarkButton(  )


/**  homepageButton(  )
  Author Lou Cypher, m435tr0d, George Dunham
  Args:
  Returns: Nothing
  Scope:   private
  Called:  By custombuttons context menu.
  Purpose: To Open the buttons homepage
**/
custombuttons.homepageButton = function ( oBtn ) //{{{
{
   var Button = ( oBtn )? oBtn : document.popupNode;
   openUILink(Button.getAttribute("homepage"));
}; //}}} End Method homepageButton(  )


/**  homepageButtonTB(  )
  Author George Dunham
  Args:
  Returns: Nothing
  Scope:   private
  Called:  By custombuttons context menu in ThunderbirdOverlay.xul.
  Purpose: To Open the buttons homepage
**/
custombuttons.homepageButtonTB = function ( oBtn ) //{{{
{
  let Button = ( oBtn )? oBtn : document.popupNode;
  // first construct an nsIURI object using the ioservice
  let ioservice = Components.classes["@mozilla.org/network/io-service;1"]
          .getService(Components.interfaces.nsIIOService);
  let uriToOpen = ioservice.newURI( Button.getAttribute( "homepage" ), null, null);
  let extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
            .getService(Components.interfaces.nsIExternalProtocolService);
  // now, open it!
  extps.loadURI( uriToOpen, null);
}; //}}} End Method homepageButtonTB(  )

/**  getButtonParameters( num )
  Author Yan, George Dunham

  Args:    num
  Returns: ret,
  Scope:   private
  Called:
  Purpose:
  Updated 8/23/2007 to format and document the function
**/
custombuttons.getButtonParameters = function ( but ) //{{{
{
  var ret = null;
  if (!but) return false;
  var ret = {
    "name":     but.getAttribute("label")||but.getAttribute("value")||"",
    "image":    but.getAttribute("image")||"",
    "code":     but.getAttribute("cb-oncommand")||cb2String.sOvrlyCB2codeDefault,
    "initCode": but.getAttribute("cb-init")||cb2String.sOvrlyCB2icodeDefault,
    "Help":     but.getAttribute("Help") || but.getAttribute("help").split(",")[1] || ""
  };
  return ret;
}; //}}} End Method getButtonParameters2(num )

/**  getButtonParameters2( num )
  Author Yan, George Dunham

  Args:    num
  Returns: ret,
  Returns: Nothing
  Scope:  private
  Called:
  Purpose:
  Updated 8/23/2007 to format and document the function
**/
custombuttons.getButtonParameters2 = function ( num ) //{{{
{
  var ret = null;
  var but1 = this.gToolbox.palette.getElementsByAttribute("id","custombuttons-button"+num)[0];
  var but = document.getElementById( "custombuttons-button"+num );
  if (!but) return false;
  var sHelp = but.getAttribute("Help") || but.getAttribute("help") || ""
  var ret = {
    "name":     but.getAttribute("label")||"",
    "image":    but.getAttribute("image")||"",
    "code":     but.getAttribute("cb-oncommand")||cb2String.sOvrlyCB2codeDefault,
    "initCode": but.getAttribute("cb-init")||cb2String.sOvrlyCB2icodeDefault,
    "Help":     sHelp
  };
  return ret;
}; //}}} End Method getButtonParameters2(num )

/**  addToPalette( button )
  Author George Dunham

  Args:
     button
  Returns: Nothing
  Scope:   private
  Called:  By
  Purpose: To Appent the button to the toolkit
**/
custombuttons.addToPalette = function ( button ) //{{{
{
  // debugger
  this.gToolbox.palette.appendChild( button );
}; //}}} End Method addToPalette( button )


/**  isCustomizableToolbar( aElt )
  Author Yan, George Dunham

  Args:
     aElt
  Returns:
     aElt.localName == "toolbar" && aElt.getAttribute("customizable") == "true",
  Returns: boolean aElt.localName == "toolbar" && aElt.getAttribute("customizable") == "true"
  Scope:   private
  Called:  By setButtonParameters()
  Purpose: To determine if a toolbar ( aElt ) will accept a custombutton
**/
custombuttons.isCustomizableToolbar = function(aElt) //{{{
{
  return aElt.localName == "toolbar" && aElt.getAttribute("customizable") == "true";
}; //}}} End Method isCustomizableToolbar( aElt )


/*---- hack to try to improve bug with Function.prototype disappearance ---*/
/**  reinitFunctionPrototypeBind(  )
  Author Yan - A Yan hack to work around a mozilla bug.

  Args:
  Returns: Nothing
  Scope:   private
  Called:  By initializeButton()
  Purpose: To

     TODO:
**/
custombuttons.reinitFunctionPrototypeBind = function (  ) //{{{
{
  if ((typeof Function.prototype.bind)==CB2const.VOID){
    dump( cb2String.sOvrlyReinitErrDump )
    Function.prototype.bind=function(object){
      var method = this;
      return function(){
        return method.apply(object, arguments)
      }
    }
  }
}; //}}} End Method reinitFunctionPrototypeBind(  )

/*--- end hack ---*/


/**  getToolbars(  )
  Author Yan, George Dunham

  Args:

  Returns:
     toolbars,
  Returns: An array of toolbars.
  Scope:   private
  Called:  By
  Purpose: To

     TODO:
**/
custombuttons.getToolbars = function (  ) //{{{
{
  //used.verified 9/20/2007
  var toolbars=new Array;
  var main_toolbars=document.getElementsByTagName("toolbar");
  for (var i = 0; i < main_toolbars.length; i++) {
    toolbars.push(main_toolbars[i]);
  }

  //BEGIN AIOS binding toolbars
  //added support for tbx 15.06.2006
  var aiostbx_bindingBoxes = new Array(  "aiostbx-tableft-toolbox",
              "aiostbx-tabright-toolbox",
              "aiostbx-belowtabs-toolbox",
              "tbx-tableft-toolbox",
              "tbx-tabright-toolbox",
              "tbx-belowtabs-toolbox"
              );
  var aios_toolbox;
  for(var i = 0; i < aiostbx_bindingBoxes.length; i++) {
    aios_toolbox=document.getElementById(aiostbx_bindingBoxes[i]);
    if(aios_toolbox){
      for (var j = 0; j < aios_toolbox.childNodes.length; j++) {
        toolbars.push(aios_toolbox.childNodes[j]);
      }
    }
  }
  //END AIOS belowtabs toolbars
  return toolbars;
}; //}}} End Method getToolbars(  )


/**  insertToToolbar( toolbar, newItem, aBeforeElt )
  Author Yan, George Dunham

  Args:
     toolbar
     newItem
     aBeforeElt
  Returns: Nothing
  Scope:   private
  Called:  this.cloneButton
           this.installWebButton
           this.App.setButtonParameters in Minefield
           createButton
  Purpose: To insert a non xul button in to the chosen toolbar

     TODO:
**/
custombuttons.insertToToolbar = function ( toolbar, newItem, aBeforeElt ) //{{{
{
//checked-used
  let oRet = {};
  if (aBeforeElt){
    oRet = toolbar.insertBefore(newItem, aBeforeElt);
  }
  else {
    oRet = toolbar.appendChild(newItem);
  }
  return oRet;
}; //}}} End Method insertToToolbar( toolbar, newItem, aBeforeElt )



/**  viewCodes(  )
  Author Lou Cypher, m435tr0d, George Dunham

  Args:
  Returns: Nothing
  Scope:   private
  Called:  By content context menu when focused on a button link.
  Purpose: To create and load a pair of frames which display
  the code fields in a new tab or window.
     TODO:
**/
custombuttons.viewCodes = function (  ) //{{{
{
  debugger
  var cb = gContextMenu.linkURL;
  var s = this.oSplitButtonURI(cb)
  if ( typeof s != CB2const.BOOLEAN ){        // Success
    var isChromeImg = s.image.indexOf("chrome://") === 0;
    var icon = isChromeImg ? "" : s.image;
    var name = s.name
    var frameURI = "data:application/x-javascript;charset=utf-8,";
    var frame1 = frameURI + encodeURIComponent(s.code+"\nHelp\n" +
                                               s.Help);
    var frame2 = frameURI + encodeURIComponent(s.initCode);
    var html =
    "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\">\n" +
    "<html>\n" +
    "<head>\n" +
    "<title>" + name + "</title>\n" +
    "<link rel=\"shortcut icon\" href=\"" + icon +"\" >\n" +
    "</head>\n" +
    "<frameset rows=\"50%,*\">\n" +
    "<frame name=\"code\" src=\"" + frame1 +
      "\" style=\"background-color: #ddf1d8; color: #000;\">\n" +
    "<frame name=\"init\" src=\"" + frame2 +
      "\" style=\"background-color: #fbf5c6; color: #000;\">\n" +
    "</frameset>\n" +
    "</html>\n\n";
    var dataURI = "data:text/html;charset=utf-8," + encodeURIComponent(html);
    gBrowser.selectedTab = gBrowser.addTab(dataURI);
    if (isChromeImg) {
      window.setTimeout(function() {
      gBrowser.selectedTab.setAttribute("image", s[1]);
      document.getElementById("page-proxy-favicon")
      .setAttribute("src", s[1]);
      }, 1000);
    }
  } // End if (typeof s == CB2const.BOOLEAN)
}; //}}} End Method viewCodes(  )

/**  ButtonBrt( e )
  Author Yan, George Dunham

  Args:    e
  Returns: Nothing
  Scope:   public
  Called:  1. Any process which can pass the event object.
  Purpose: 1. Highlight the button moused over
**/
custombuttons.ButtonBrt = function ( e ) //{{{
{
  if ( e.target.id.indexOf("custombuttons-button") > -1 ){ // Added 8/8/2007 7:00 PM
    e.target.style.opacity = ( !e.target.disabled )? "0.99" : ".25" ;
  } // End if
}; //}}} End Method ButtonBrt( e )
/**  ButtonDim( e )
  Author Yan, George Dunham

  Args:    e
  Returns: Nothing
  Scope:   public
  Called:  1. Any process which can pass the event object.
  Purpose: 1. Dim the button when the mouse leaves
**/
custombuttons.ButtonDim = function ( e ) //{{{
{
  if ( e.target.id.indexOf("custombuttons-button") > -1 ){ // Added 8/8/2007 7:00 PM
    e.target.style.opacity = ( !e.target.disabled )? "0.65" : ".25" ;
  } // End if
}; //}}} End Method ButtonDim( e )

/**  getNumber( id )
  Author Yan, George Dunham

  Args:    id
  Returns: sNum,
  Scope:   public
  Called:  1. Any process which must pass a complete custom button
  Purpose: 1. Strip "custombuttons-button" from the id and return
              the number
  UPDATED: 8/26/2007
**/
custombuttons.getNumber = function ( id ) //{{{
{
  var sNum = id.replace(/custombuttons-button/,"");
  return sNum;
}; //}}} End Method getNumber( id )

/**  min_button_number(  )
  Author Yan, George Dunham

  Args:
  Returns: z
  Scope:   public
  Called:  1. cloneButton
           2. setButtonParameters
           3. createButton
  Purpose: 1.
  TODO:    Modify to use modern methods
  UPDATED: 10/31/2007 skip button 0
**/
custombuttons.min_button_number = function (  ) //{{{
{
  var z = 1;  //0;
  var bt=new Object();
  for ( var j = 0; j < this.gToolbox.palette.childNodes.length; j++ ){
    var but=this.gToolbox.palette.childNodes[j];
    if (but.getAttribute( "id" ).indexOf( "custombuttons-button" ) != -1 ){ // our type.
      var n=this.getNumber( but.getAttribute("id") );
      bt[n]=true;
    }
  }
  while ( typeof bt[z] != CB2const.VOID ) z++;
  return z;
}; //}}} End Method min_button_number(  )

/**  uCstrpad( arr )
 *  Author Yan, George Dunham
 *
 *  Args:    arr
 *  Returns: sRet,
 *  Scope:   private
 *  Called:  1.
 *  Purpose: Pad the string in cell 0 of the passed array for centering.
 */
custombuttons.uCstrpad = function ( arr ) //{{{
{
  var sRet = null;
  var nlong = 0;
  for (var i in arr) {
    nlong = (arr[i].length > nlong)? arr[i].length : nlong ;
  }
  sRet = (nlong - arr[0].length) /1.2;
  return sRet;
}; //}}} End Method uCstrpad( arr )

/**  findButtonOnBars( sButtonId )
 Author:    George Dunham aka: SCClockDr
 Scope:     global
 Args:      sButtonId -

 Returns:   aRet
 Called by: 1.
 Purpose:   1. Iterate through the customizable toolbars and find the submitted button.
 */
custombuttons.findButtonOnBars = function(sButtonId) //{{{
{
  let aRet = null;
  //toolbar
  var toolbars=this.getToolbars();
  for (var i = 0; i < toolbars.length; ++i) {
    var toolbar = toolbars[i];
    if (this.isCustomizableToolbar(toolbar)) {
      // Iterate throughthe toolbar elements looking for this newButton2
      for (var j = 0;j<toolbar.childNodes.length;j++){
        if (toolbar.childNodes[j].getAttribute("id")==sButtonId){
          aRet = [toolbar,toolbar.childNodes[j]]
          break;
        }
      }
    }
  }
  return aRet;
}; //}}} End Method findButtonOnBars( sButtonId )

/**  setButtonParameters( num, values )
  Author Yan, George Dunham

  Args:    num
           values
  Returns: Nothing
  Scope:   public
  Called:
     1. this.installWebButton
     2. editor.setButtonParameters
     3. Any process that passes a button number and a values
        object.
  Purpose:
     1. Add the button to the appropriate toolbar.
     2. Add the button to the gToolbox.
     3. Save the buttons to buttonsoverlay.xul
**/
custombuttons.setButtonParameters = function ( num, values ) //{{{
{
  if (num){
    // we substitute button in Palette and on the panel to that renovated
    var newButton=this.createButton(num,values);
    var newButton2=this.createButton(num,values);
    //toolbar
    var toolbars=this.getToolbars();
    for (var i = 0; i < toolbars.length; ++i) {
      var toolbar = toolbars[i];
      if (this.isCustomizableToolbar(toolbar)) {
        // Iterate throughthe toolbar elements looking for this newButton2
        for (var j = 0;j<toolbar.childNodes.length;j++){
          if (toolbar.childNodes[j].getAttribute("id")==newButton2.id){
            toolbar.replaceChild(newButton2,toolbar.childNodes[j]);
            break;
          }
        }
      }
    }
    //palette
    for (var j = 0;j<this.gToolbox.palette.childNodes.length;j++){
      if (this.gToolbox.palette.childNodes[j].getAttribute("id")==newButton.id){
        this.gToolbox.palette.replaceChild(newButton,this.gToolbox.palette.childNodes[j]);
        break;
      }
    }
  }
  else {
    //checked
    var str=cb2String.sButtonAddedAlert
    var Ttl=cb2String.sButtonAddedTitle.replace(/%s/gi,values.name)
    try{
    num=this.min_button_number();
    var newButton=this.createButton(num,values);
    // palette
    this.addToPalette(newButton);
    this.alertBox(Ttl, str);
    } catch(e) {
      this.alertBox( Ttl, e );
    }
  }
  this.App.saveButtonsToProfile();
}; //}}} End Method setButtonParameters( num, values )


/**  oSplitButtonURI( uri )
  Author      Yan, George Dunham
  Args:       uri
  Returns:    ar
  Scope:      public
  Called By:  1. Any process that pass a valid custombutton uri.
  Purpose:    1. Accept a valid button uri and return a 4 cell array
                 with name, image, Code, and Icode data.
  ADDED: 9/26/2007
  TODO: 9/2/2008 Institute mod to handle BBCode and Hyperlinks.

**/
custombuttons.oSplitButtonURI = function ( uri ) //{{{
{
  // New Method of oSplitting the Button Parameters
  // debugger
  uri = unescape( uri );
  var ar = null;
  var az = [CB2const.bFieldSepEscaped, CB2const.bFieldSepUTF8, CB2const.bFieldSepNew, CB2const.bFieldSepNewx];
  var idx = -1;
  var sep =  "";

  if (uri.indexOf("<?xml") == 15){ // We have an xml type button
    uri = uri.substring(15);
    let oValues = {}, test = [];
    let tmp = new DOMParser ();
    let butLink = tmp. parseFromString(uri, "text/xml");
    oValues.name = unescape(butLink.getElementsByTagName("name")[0].textContent);
    oValues.image = unescape(butLink.getElementsByTagName("image")[0].firstChild.textContent);
    oValues.code = unescape(butLink.getElementsByTagName("code")[0].firstChild.textContent);
    oValues.initCode = unescape(butLink.getElementsByTagName("initcode")[0].firstChild.textContent);
    gClipboard.write(oValues.initCode);
    oValues.mode = butLink.getElementsByTagName("mode")[0].textContent;
    test = butLink.getElementsByTagName("help")
    oValues.Help = unescape((test.length > 0)? test[0].textContent : this.CbStr.sOvrlyCB2buttonHelpstr);
    return oValues;
  } // End if

  for ( var i = 0; i < az.length; i++) {
    idx = (idx >= 0)? idx : ( uri.indexOf(az[i]) > -1 )? i : idx ;
  } // End for
  sep = (idx >= 0)? az[idx] : CB2const.bFieldSep;
  var ar =  uri.split( sep );          // Split button
  if (ar.length == 5 || ar.length == 4 ) {
    if ( ar[0].indexOf("[cb=custombutton://") > -1 || ar[0].indexOf("<a href=\"custombutton://") > -1 ) {
      var sReason = ( ar[0].indexOf("[cb=custombutton://") > -1 )? cb2String.sOvrlyCB2ErrorSplitButtonRBBCode : cb2String.sOvrlyCB2ErrorSplitButtonRHyperl;
      // BBCode and Hyperlink Button links direct from the Context Menu not reliable.
      this.confirmBox( cb2String.sOvrlyCB2ErrorSplitButton, cb2String.sOvrlyCB2ErrorSplitButtonErr.replace( /%s/, sReason ), cb2String.sOvrlyContinueButton, null );
      return false;
    } // End if ( ar[0].indexOf("[cb=custombutton://") > -1 || ar[0].indexOf("<a href="custombutton://") > -1 )
  } // End if ( ar.length == 5  )
  else {  // We Don't have 4  or 5 fields
    var sReason = ( ar.length != 4 )? cb2String.sOvrlyCB2ErrorSplitButtonRfields : cb2String.sOvrlyCB2ErrorSplitButtonRClass + ar[0].substr(0,20);
    this.confirmBox( cb2String.sOvrlyCB2ErrorSplitButton, cb2String.sOvrlyCB2ErrorSplitButtonErr.replace( /%s/, sReason ), cb2String.sOvrlyContinueButton, null );
    return false;
  } // End else
  var sTmp = "";
  sTmp = ar[0].replace(/^custombutton\:\/\//, "");      // Remove link ID
  ar[0] = sTmp.replace(/^\/\//, "");
  var n = ar[3].indexOf( "//..." );
  ar[3] = ( n > -1 )? ar[3].substr( 0, n ) : ar[3] ;
  if (ar.length == 4) { ar.push(""); }
  return this.convButFieldsToObj( ar );
}; //}}} End Method oSplitButtonURI( uri )


/**  convButFieldsToObj( aFields )
 Author:  George Dunham aka: SCClockDr
 Scope:   global
 Args:    aFields -
 *
 Returns: oRet
 Called:  1. Any Process
 Purpose: 1. Convert arrayed fields to an object
 ADDED:   9/26/2007
 */
custombuttons.convButFieldsToObj = function( aFields ) //{{{
{
  var oRet =
  {
    name:     aFields[0] || "",
    image:    aFields[1] || "",
    code:     aFields[2] || cb2String.sOvrlyCB2codeDefault,
    initCode: aFields[3] || cb2String.sOvrlyCB2icodeDefault,
    Help: aFields[4] || ""
  };
  return oRet;
}; //}}} End Method convButFieldsToObj( aFields )

/**  custombuttons.getCbVers(  )
 Author:  George Dunham aka: SCClockDr
 Scope:   global
 Args:
 Returns: sCbVers
 Called:  1. this.init()
 Purpose: 1. Establish the current Extension Version.
 */
custombuttons.getCbVers = function(  ) //{{{
{
  let sCbVers = null;
  let em = Components.classes["@mozilla.org/extensions/manager;1"]
       .getService(Components.interfaces.nsIExtensionManager);
  // Change extension-guid@example.org to the GUID of the extension whose version
  // you want to retrieve, e.g. foxyproxy@eric.h.jung for FoxyProxy
  let addon = em.getItemForID(CB2const.sCbGUID);
  sCbVers = addon.version;
  return sCbVers;
}; //}}} End Method custombuttons.getCbVers(  )

/**  compareVersion( sSample, sBase )
 * Author:  George Dunham aka: SCClockDr
 * Scope:   global
 * Args:    sSample - The version number in question.
 *          sBase - The version comparison standard.
 * Returns: nRet
 * Called:  1. Any Process
 * Purpose: 1. Return comparison flag:
 *      -1 = sSample older than sBase,
 *       0 = sSample equals sBase,
 *       1 = sSample newer than sBase
 */
custombuttons.compareVersion = function( sSample, sMyStd ) //{{{
{
  return Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator).compare( sSample, sMyStd );
}; //}}} End Method compareVersion( sSample, sBase )


/**  gAppVersion(  )
 * Author:  George Dunham aka: SCClockDr
 * Scope:   global
 * Args:
 * Returns: sRet
 * Called:  1.
 * Purpose: 1.
 */
custombuttons.gAppVersion = function(  ) //{{{
{
  debugger
  var sRet = null;
  // assuming we're running under Firefox
  var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
        .getService(Components.interfaces.nsIXULAppInfo);
  sRet = appInfo.version;
  return sRet;
}; //}}} End Method gAppVersion(  )


/**  gVersion( sGUID )

 Scope:   global
 Args:    sGUID -
 Returns: sRet
 Called:  1. Any process
 Purpose: 1. Return the current Extension Version
**/
custombuttons.gVersion = function ( sGUID ) //{{{
{
  let sRet = null;
  if ( typeof sGUID != "string" ) {
    sGUID = CB2const.sCbGUID;
  } // End if ( typeof sGUID != "string" )
  let em = Components.classes["@mozilla.org/extensions/manager;1"]
         .getService(Components.interfaces.nsIExtensionManager);
  let addon = em.getItemForID( sGUID );
  sRet = addon.version;
  return sRet;
}; //}}} End Method gVersion( sGUID )



/**  BackupFile( str, fname )
  Author Yan, George Dunham

  Args:
     str
     fname
  Returns: Nothing
  Scope:   private
  Called:
  Purpose: To

  UPDATED: 12/6/2007 Bug Fix cb2String ==> CB2const
**/
custombuttons.BackupFile = function ( str, fname ) //{{{
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, cb2String.sOvrlyCB2savThsBtnFPickP.replace(/%s/gi,fname), nsIFilePicker.modeSave);
  fp.defaultString = fname +".html";
  fp.appendFilters(fp.filterHTML);
  fp.appendFilters(fp.filterAll);
  // other filters
  var res=fp.show();
  if ( res == nsIFilePicker.returnOK || res==nsIFilePicker.returnReplace){
    var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
      createInstance(Components.interfaces.nsIFileOutputStream);
    outputStream.init( fp.file, 0x04 | 0x08 | 0x20,777, 0 );
    var result = outputStream.write( str, str.length );
    outputStream.flush();
    outputStream.close();
  }
}; //}}} End Method BackupFile( str, fname )

/**  commitTbChanges( toolBar, sNset )
  Author Lou Cypher, George Dunham

  Args:    toolBar
           sDat
           sTarg1
           sTarg2
  Returns: Nothing
  Scope:   private
  Called By:
     1. this.removeButton
     2. this.cloneButton
     3. this.createButton
     4. createButton
  Purpose To:
     1. Update localstore.rdf
     2. Save the buttons to buttonsoverlay.xul
  UPDATED: 10/31/2007 To stabilize toolbar decoration issues
  UPDATED: 11/30/2007 Bug Fix attrNam to attrName
  2007-11-30
**/
custombuttons.commitTbChanges = function ( toolBar, sDat, sTarg1, sTarg2 ) //{{{
{
  // We update the currentSet for toolbar
  var customindex=toolBar.getAttribute("customindex");
  var sNewSet, toolbarSet, attrName;
  if (customindex>0){    // Custom Toolbar
    toolbarSet = document.getElementById( "customToolbars" );
    attrName="toolbar"+customindex;
    if ( sTarg2 ) {    // Remove Button
      if ( toolbarSet.getAttribute( attrName ).indexOf( "," ) == -1 ) {
        // Last element
        sNewSet = toolbarSet.getAttribute(attrName).replace(sTarg2.substr(1), sDat);
        // Remove custom toolbars whose contents have been removed.
        this.gToolbox.removeChild(toolBar);
        // Remove toolbarX attributes for removed toolbars.
        let gToolboxDocument = this.gToolbox.ownerDocument;
        this.gToolbox.toolbarset.removeAttribute(attrName);
        gToolboxDocument.persist(this.gToolbox.toolbarset.id, attrName);
      }
      else {
        // Other elements exist
        sNewSet = toolbarSet.getAttribute(attrName).replace(sTarg1, sDat).replace(sTarg2, sDat);
        toolbarSet.setAttribute( attrName, sNewSet );
        document.persist("customToolbars",attrName);
      } // End if ( toolbarSet.getAttribute(attrName).indexOf( "," ) )
    }
    else {  // Update Custom Toolbar
      sNewSet = toolbarSet.getAttribute(attrName).replace(sTarg1, sTarg1+ "," + sDat);
      toolbarSet.setAttribute( attrName, sNewSet );
      document.persist("customToolbars",attrName);
    } // End if ( sDat2 )
  }
  else {    // XUL Toolbar
    if ( sTarg2 ) {    // Remove Button
      sNewSet = toolBar.getAttribute( "currentset" ).replace(sTarg1, sDat).replace(sTarg2, sDat);
    }
    else {    // Update XUL Toolbar
      sNewSet = toolBar.getAttribute( "currentset" ).replace(sTarg1, sTarg1+ "," + sDat);
    } // End if ( sDat2 )
    toolBar.setAttribute( "currentset", sNewSet )
    document.persist(toolBar.id, "currentset");
  }
  // Corrections for AIOS
  if (document.getElementById("aiostbx-belowtabs-toolbox")) persistCurrentSets();
  // this.App.saveButtonsToProfile( this );
}; //}}} End Method commitTbChanges( toolBar, sNset )

/**  getHiddenLabel( oBtn )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      oBtn -
 Returns:   sRet
 Called by: 1. Anyone
 Purpose:   1. Retrieve a button's hidden label or a constructed one
 TODO:      1.
 */
custombuttons.getHiddenLabel = function(oBtn) //{{{
{
  return oBtn.getAttribute("label") ||
         oBtn.getAttribute("value") ||
         "Button" + this.getNumber(oBtn.getAttribute("id"));
}; //}}} End Method getHiddenLabel( oBtn )

/**  setHiddenLabel( oBtn )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      oBtn -
 Returns:   sRet
 Called by: 1. Anyone
 Purpose:   1. Set a Button's hidden label to make it availabel for view.
 */
custombuttons.setHiddenLabel = function(oBtn) //{{{
{
  oBtn.setAttribute("label",this.getHiddenLabel(oBtn))
}; //}}} End Method setHiddenLabel( oBtn )

/**  saveButtonsToProfile(  )
  Author Yan, George Dunham

  Args:
  Returns: Nothing
  Scope:   public
  Called by:
     1. Any process that wants to commit the buttons in gToolbox
        to disk.
  Purpose:
     1. Commit the custombuttons in the gToolbox to disk.
**/
custombuttons.saveButtonsToProfile = function ( sFileBaseName, sToolbarPalette ) //{{{
{
  var doc = document.implementation.createDocument("", "", null);
  var overlay = doc.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul","overlay");
  overlay.setAttribute("id","custombuttons-profile-overlay");
  doc.appendChild(overlay);
  var palette=doc.createElement("toolbarpalette");
  palette.setAttribute("id", sToolbarPalette );
  overlay.appendChild(palette);
  var copiedAttributes={
    "class":true,
    "id":true,
    "label":true,
    "image":true,
    "cb-oncommand":true,
    "cb-init":true,
    "Help":true,
    "context":true,
    "tooltiptext":true,
    "initialized":true,
    "hidden": true
  };
  //adding buttons from palette to new doc
  var newButton = {}, aSortArr = new Array([],[],[]);
  for (var j=0;j<this.gToolbox.palette.childNodes.length;j++){
    var but=this.gToolbox.palette.childNodes[j];
    if (but.getAttribute("id").indexOf("custombuttons-button")!=-1){     // Our Kind of button
      newButton=doc.createElement(but.nodeName);
      for (var a in copiedAttributes){
        if (copiedAttributes[a] && but.hasAttribute(a)) newButton.setAttribute(a,but.getAttribute(a));
      } // End for
      if (!document.getElementById( but.id )) newButton.setAttribute("initialized",false);
      this.setHiddenLabel(but);
      // Build buttonsoverlay.xul sort array
      aSortArr[0].push(this.getNumber(newButton.getAttribute("id")));
      aSortArr[1].push(this.getNumber(newButton.getAttribute("id")));
      aSortArr[2].push(newButton);
    }
  }

  // function to sort numeric array
  function numsort(a,b){
    return a-b;
  }
  aSortArr[0].sort(numsort);
  var nIndex = -1;
  var tmp = "";
  for (var i in aSortArr[0]) {  // This arranges the palette in ID order
    nIndex = aSortArr[1].indexOf(aSortArr[0][i]);
    newButton = aSortArr[2][nIndex];
    palette.appendChild(newButton);
  } // End for

  // End Manage the New Button Buffer

  var serializer = new XMLSerializer();
  var data = serializer.serializeToString(doc);

  //beautifull output
  XML.prettyPrinting=true;
  data=(new XML(data)).toXMLString ();


  var uniConv = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
    .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
  uniConv.charset = "utf-8";
  data = uniConv.ConvertFromUnicode(data);

  var dir = Components.classes["@mozilla.org/file/directory_service;1"]
       .getService(Components.interfaces.nsIProperties)
       .get("ProfD", Components.interfaces.nsIFile); // get profile folder
  dir.append("custombuttons");
  if (!dir.exists()) {
    try{
      dir.create(0x01, 0755);
    } catch(e){
      var msg="[ "+cb2String.sOvrlyCB2Error+" ]\n"
        +"[ "+cb2String.sOvrlyCB2ErrorCreateDir+" ]\n"
        +"[ "+e+" ]";
      Components.utils.reportError(msg);
    }
  }

  //creating backup
  var backupfile=dir.clone();
  backupfile.append( sFileBaseName + ".xul.bak" );

  var file=dir.clone();
  file.append( sFileBaseName + ".xul" );
  if (file.exists()){
    if (backupfile.exists()) {
      backupfile.remove(false);
    }
    file.copyTo(dir, sFileBaseName + ".xul.bak" );
  }

  var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
    .createInstance(Components.interfaces.nsIFileOutputStream);
    var flags = 0x02 | 0x08 | 0x20; // wronly | create | truncate
    foStream.init(file, flags, 0755, 0);
    foStream.write(data, data.length);
    foStream.flush();
    foStream.close();
}; //}}} End Method saveButtonsToProfile(  )

/**  custombuttons.reIdButton( oBtn )
 Author:  George Dunham aka: SCClockDr
 Scope:   private
 Args:    oBtn -
 *
 Returns: Nothing
 Called by:  1.
 Purpose:   1.
 ADDED:  10/31/2007 For Auto install of Import a Button as button 0
 */
custombuttons.reIdButton = function( oBtn ) //{{{
{
  // Clone button 0
  this.cloneButton( oBtn );
  // Remove button 0
  this.removeButton( oBtn );
}; //}}} End Method custombuttons.reIdButton( oBtn )


/**  getLocalString( btn, sRef )
 Author:    George Dunham aka: SCClockDr
 Scope:     global
 Args:      btn -
            sRef -
 Returns:   p[locale][sRef]
 Called by: 1. Any Button Process wanting to retrieve a localized String.
 Purpose:   1. Return a localized String
 */
custombuttons.getLocalString = function( btn, sRef ) //{{{
{
  var p = btn.properties;
  var defaultLocale = "en_US";
  var locale = this.getPrefs( "general.useragent.locale" ).replace(/\-/,"_");
  if ( p[locale] && p[locale][sRef] ) {
    return p[locale][sRef];
  } // End if ( p[locale] && p[locale][sRef] )
  return p[defaultLocale][sRef];
}; //}}} End Method getLocalString( btn, sRef )

/**  readFile( fPath )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      fPath -
 Returns:   sRet
 Called by: 1.
 Purpose:   1.
 */
custombuttons.readFile = function(fPath) //{{{
{
  let sRet = null;
  let file = null;
  fPath = (fPath.indexOf(':\\') > -1 )? fPath.replace(/\//g,'\\') : fPath;
  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  } catch (e) {
    alert("Permission to read file was denied.");
  }
  file = Components.classes["@mozilla.org/file/local;1"]
    .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath( fPath );
  let is = Components.classes["@mozilla.org/network/file-input-stream;1"]
    .createInstance( Components.interfaces.nsIFileInputStream );
  is.init( file,0x01, 00004, null);
  let sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
    .createInstance( Components.interfaces.nsIScriptableInputStream );
  sis.init( is );
  sRet = sis.read( sis.available() );
  return sRet;
}; //}}} End Method readFile( fPath )

/**  writeFile( fPath, sData )
 Author:    George Dunham aka: SCClockDr
 Scope:     private
 Args:      fPath -
            sData -
 Returns:   Nothing
 Called by: 1.
 Purpose:   1.
 */
custombuttons.writeFile = function(fPath, sData) //{{{
{
  try{
    fPath = (fPath.indexOf(':\\') > -1 )? fPath.replace(/\//g,'\\') : fPath;
    let file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file.QueryInterface(Components.interfaces.nsIFile);
    file.initWithPath( fPath );
    if( file.exists() == true ) file.remove( false );
    let strm = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    strm.QueryInterface(Components.interfaces.nsIOutputStream);
    strm.QueryInterface(Components.interfaces.nsISeekableStream);
    strm.init( file, 0x04 | 0x08, 420, 0 );
    strm.write( sData, sData.length );
    strm.flush();
    strm.close();
  }catch(ex){
    window.alert(ex.message+'nnn');
  }

}; //}}} End Method writeFile( fPath, sData )


