﻿/**************************************************************
 *                          editor.js                         *
 **************************************************************/

/**  Object editor
 Author:  George Dunham aka: SCClockDr

 Scope:   Public
 Properties:
    Cb -
 Methods:
    onLoad -
    setValues -
    setButtonParameters -
    select_image -
    convert_image -
    setImageURL -
    execute_oncommand_code -
 Purpose:  1. Supports creating and editing Custom Buttons² buttons.
**/
var editor =  //{{{
{
  // Properties:
  Cb: null,
  gClipboard: null,
  CON: null,
  CbStr: null,
  bSoftTab: false,
  bSoftTabWidth: 2,
  editorIndex: -1,
  // Methods
  /**  onLoad(  )

   Scope:   private
   Args:
   Returns: Nothing
   Called:  1. on load event.
   Purpose: 1. Open the editor dialog for creating or editing a button
   UPDATED: 1. 8/29/2007 Current onclick statement Deprecated
   UPDATED: 1. 9/26/2007 Removed Apply button from Add New Button
   TODO:    1. Make this work in a tab
  **/
  onLoad:function (  ) //{{{
  {
    var str = "";
    var sTitle = document.title;
    // this.Cb = window.opener.custombuttons;
    this.Cb = opener.custombuttons;    // UPDATED: 11/30/2007
    this.gClipboard = this.Cb.gClipboard;
    this.CON =this.Cb.CON;
    this.CbStr = this.Cb.CbStr;
    this.bSoftTab = this.Cb.getPrefs(this.CON.CBC_PREF_EDITOR_BRANCH+this.CON.CBC_PREF_SOFTAB);
    this.bSoftTabWidth = this.Cb.getPrefs(this.CON.CBC_PREF_EDITOR_BRANCH+this.CON.CBC_PREF_SOFTAB_WIDTH);
    var pref="extensions.custombuttons.editor.showApplyButton";
    this.editorIndex = this.Cb.aEditorWindows.length-1
    if (window.arguments[0]){
      var button=window.arguments[0];
      // var num=this.Cb.getNumber(button.id);
      this.Cb.App.disableCustomize(true)

      document.title = sTitle.replace(/\$s/,button.label);

      this.setValues(this.Cb.getButtonParameters(button));
      // alert([button.id, "custombuttons-button0",button.id != "custombuttons-button0"])
      if (button.id == "custombuttons-button0") {
        document.documentElement.getButton("extra2").setAttribute("hidden",true);
      } // End if ( button.id != "custombuttons-button0" )
      else {
        document.documentElement.getButton("extra2").setAttribute("hidden",
            !( this.Cb.ps.prefHasUserValue(pref) && this.Cb.ps.getBoolPref(pref)) );
      } // End else ( button.id != "custombuttons-button0" )
    } // End if (window.arguments[0]) - We are Editing an existing button
    else { // We are adding a New button.
      document.title = sTitle.replace( /\$s/, this.CbStr.sOvrlyPromptButton );

      if ( this.Cb.getPrefs("extensions.custombuttons.vanilla.button")) {
        var edtObj = {
        "name" :"",
        "image":this.Cb.defaultImg(),  // UPDATED: 11/30/2007
        "code" : this.CbStr.sOvrlyCB2codeDefault,
        "initCode" : this.CbStr.sOvrlyCB2icodeDefault +
        "\nif (typeof custombuttons.uCbuttonButes != 'function') {\n"+
        "  alert( \"" + this.CbStr.sButtonCompatabilityAlert + "\" );\n"+
        "  this.disabled(true);\n"+
        "}\n\n"+
        "var Msg = createMsg(this.label);\n\n"};
        if ( this.Cb.getPrefs("extensions.custombuttons.include.deBug" )) {
          edtObj.initCode += "var de = createDebug(this);\n\n";
        }
        if ( this.Cb.getPrefs("extensions.custombuttons.include.MouseHandler" )) {
          let sReplComment = "  // "+this.CbStr.sInitCodeReplaceWith + "\n};\n\n";
          edtObj.initCode += "\n";
          edtObj.initCode += this.Cb.commPad( this.CbStr.sInitCodeMouseHandlerCommH, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT );
          edtObj.initCode += "\n\n\t" + this.CbStr.sInitCodeMouseHandlerCommT + "\n\n";
          edtObj.initCode += this.Cb.commPad( "--", this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, null, this.CON.CODE_END_COMMENT );
          edtObj.initCode += "\n\nlet Cb2s = cb2String;\n";
          edtObj.initCode += "this.leftclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysLftClick);" + sReplComment;
          edtObj.initCode += "this.sleftclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysShiftLftClick);" + sReplComment;
          edtObj.initCode += "this.aleftclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysAltLftClick);" + sReplComment;
          edtObj.initCode += "this.cleftclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysCtrlLftClick);" + sReplComment;
          edtObj.initCode += "this.midclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysMdClick);" + sReplComment;
          edtObj.initCode += "this.smidclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysShiftMdClick);" + sReplComment;
          edtObj.initCode += "this.amidclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysAltMdClick);" + sReplComment;
          edtObj.initCode += "this.cmidclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysCtrlMdClick);" + sReplComment;
          edtObj.initCode += "this.rightclick = function(evt)\n{\n  custombuttons.gQuot.gShowPopup(this);" + sReplComment;
          edtObj.initCode += "this.arightclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysAltRtClick);" + sReplComment;
          edtObj.initCode += "this.crightclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysCtrlRtClick);" + sReplComment;
          if (this.Cb.getPrefs("extensions.custombuttons.include.MouseDblClick" )) {
            edtObj.initCode += "this.leftDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysLftDClick);" + sReplComment;
            edtObj.initCode += "this.sleftDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysShiftLftDClick);" + sReplComment;
            edtObj.initCode += "this.aleftDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysAltLftDClick);" + sReplComment;
            edtObj.initCode += "this.cleftDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysCtrlLftDClick);" + sReplComment;
            edtObj.initCode += "this.midDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysMdDClick);" + sReplComment;
            edtObj.initCode += "this.smidDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysShiftMdDClick);" + sReplComment;
            edtObj.initCode += "this.amidDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysAltMdDClick);" + sReplComment;
            edtObj.initCode += "this.cmidDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysCtrlMdDClick);" + sReplComment;
            edtObj.initCode += "this.rightDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysRtDClick);" + sReplComment;
            edtObj.initCode += "this.srightDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysShiftRtDClick);" + sReplComment;
            edtObj.initCode += "this.arightDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysAltRtDClick);" + sReplComment;
            edtObj.initCode += "this.crightDclick = function(evt)\n{\n  Msg.aMsg(Cb2s.sNBkeysCtrlRtDClick);" + sReplComment;
          } // End if ( this.Cb.getPrefs("extensions.custombuttons.include.MouseDblClick" )) )// Double Click Code
          edtObj.initCode += "\nthis.setAttribute( 'onclick', 'custombuttons.gQuot.mHandler( event, this )' ); "+this.CbStr.sNBonClickComment;
          if (this.Cb.getPrefs("extensions.custombuttons.include.MouseDblClick" )) edtObj.initCode += "\nthis.setAttribute( 'ondblclick', 'custombuttons.gQuot.mHandler( event, this )' );\n";
          // edtObj.initCode += "\nthis.setAttribute( 'onclick', 'gQuot( event )' ); "+this.CbStr.sNBonClickComment + "\n";
          edtObj.initCode += "\n";
          edtObj.initCode += this.Cb.commPad( this.CbStr.sInitCodeMouseHandlerCommE, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
        }
        edtObj.initCode += "\n";
        edtObj.initCode += this.Cb.commPad( this.CbStr.sInitCodeCommH, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
        edtObj.initCode += "\n\n";
        edtObj.initCode += this.Cb.commPad( this.CbStr.sInitCodeCommE, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
        if ( this.Cb.getPrefs("extensions.custombuttons.include.ShowFocus" )) {
          edtObj.initCode += "\n" + this.Cb.commPad( this.CbStr.sInitCodeShowFH, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
          edtObj.initCode += "\n\nthis.style.opacity = '.65';\n"+
            "this.setAttribute(\"onmouseover\", \"if (custombuttons) custombuttons.ButtonBrt(event);\" );\n"+
            "this.setAttribute(\"onmouseout\", \"if (custombuttons) custombuttons.ButtonDim(event);\" );\n\n";
          edtObj.initCode += this.Cb.commPad( this.CbStr.sInitCodeShowFE, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
        }
        if ( this.Cb.getPrefs("extensions.custombuttons.include.Attributes" )) {
          edtObj.initCode += "\n" + this.Cb.commPad( this.CbStr.sInitAttributesCommH, this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
          edtObj.initCode += "\nthis.setAttribute('author','"+(this.Cb.getPrefs('extensions.custombuttons.Attributes.author'))+"');\n"+
          "this.setAttribute('version','');\n";
          var x = "this.setAttribute('homepage','"
          if (this.Cb.isPref( 'extensions.custombuttons.include.HomePageHidden' )) {
            x += this.Cb.getPrefs('extensions.custombuttons.include.HomePageHidden' )+"' );\n"
          }
          else {
            x += this.Cb.getConst( "sCB2Homepage" ) + "');\n";
          }
          edtObj.initCode += x
          edtObj.initCode += "this.setAttribute('dependency','"+(this.Cb.getPrefs('extensions.custombuttons.Attributes.dependency' ))+"');\n"+
          "this.setAttribute('status','"+(this.Cb.getPrefs('extensions.custombuttons.Attributes.status' ))+"');\n"+
          "this.setAttribute('public',"+(this.Cb.getPrefs('extensions.custombuttons.Attributes.public' )? 'true' : 'false')+");\n";
          edtObj.initCode += ( this.Cb.isPref("extensions.custombuttons.include.ToolTipExtension" ))? this.Cb.getPrefs("extensions.custombuttons.include.ToolTipExtension" ) : ""
          edtObj.initCode += "\n\n" + this.Cb.commPad( this.CbStr.sInitAttributesCommE , this.CON.BUTTON_COMMENT_FILLER,
                         this.CON.CODE_COMMENT_WIDTH, this.CON.CODE_START_COMMENT, this.CON.CODE_END_COMMENT );
          edtObj.Help =this.Cb.getPrefs("extensions.custombuttons.Attributes.Help" );
        }
        this.setValues(edtObj);
      }
      document.documentElement.getButton("extra2").setAttribute("hidden",true);
    }
    //ï¿½ï¿½ï¿½ï¿½ï¿½ï¿½ï¿½ï¿½ï¿½ï¿½ ï¿½ï¿½ï¿½ï¿½ï¿½ï¿½ bind
    if (typeof Function.prototype.bind == this.CON.VOID){
      Function.prototype.bind=window.opener.Function.prototype.bind;
    }
    //disable spellchecking
    // var sCh=document.getElementById("code").spellCheckerUI;
      // if (sCh) sCh.mInlineSpellChecker.enableRealTimeSpell=false;
    // sCh=document.getElementById("initCode").spellCheckerUI;
      // if (sCh) sCh.mInlineSpellChecker.enableRealTimeSpell=false;

  }, //}}} End Method onLoad(  )
  /**  setValues( values )
   Author   George Dunham aka: SCClockDr
   Scope:   private
   Args:    values -
   Returns: Nothing
   Called:  1. onload method
   Purpose: 1. Retrieve button field values
  **/
  setValues:function ( values ) //{{{
  {
    for each (var v in this.Cb.buttonParameters){
      document.getElementById(v).value=values[v];
    }
  }, //}}} End Method setValues( values )
  /**  setButtonParameters(  )

   Scope:   private
   Args:
   Returns: Nothing
   Called:  1. ondialogaccept (Apply or OK buttons)
   Purpose: 1. Set values into the button's fields
  **/
  setButtonParameters:function ( close ) //{{{
  {
    var values={}, lRet, nRet;
    for each (var v in this.Cb.buttonParameters){
      values[v]=document.getElementById(v).value;
    }
    if (window.arguments[0]){
      var button=window.arguments[0];
      var num=this.Cb.getNumber(button.id);
      if ( button.mObj ) {
        button.mObj.deInit();
      } // End if ( button.mObj )
        this.Cb.setWmNewButtonParameters(button, values, 2);
    }
    else {
      this.Cb.setWmNewButtonParameters(null, values, 1);
      var str = this.CbStr.sButtonAddedAlert;
      var Ttl = this.CbStr.sButtonAddedTitle.replace(/%s/gi, values.name);
      this.Cb.alertBox(Ttl, str);
    }
    if (close) this.close();
  }, //}}} End Method setButtonParameters(  )
  /**  select_image(  )

   Scope:   private
   Args:
   Returns: Nothing
   Called:  1. Editor Select Image button
   Purpose: 1. Browse and Select an image for the image field.
  **/
  select_image:function (  ) //{{{
  {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"]
	               .createInstance(nsIFilePicker);
    fp.init(window, this.CbStr.sEditFilePickSelectImage , 0);
    fp.appendFilters(nsIFilePicker.filterImages);
      var res = fp.show();
    if (res == nsIFilePicker.returnOK || nsIFilePicker.returnReplace){
      var thefile = fp.file;
      document.getElementById("image").value="file:///"+thefile.path.replace(/\\/g,"\/");
    }
  }, //}}} End Method select_image(  )
  /**  convert_image(  )

   Scope:    private
   Args:
   Returns:  Nothing
   Called:   1. base64 Button
   Purpose:  1. Convert an image to a base64 format.
  **/
  convert_image:function (  ) //{{{
  {
    var image_input=document.getElementById("image");
    var aURL=image_input.value;
    var kIOContractID = "@mozilla.org/network/io-service;1";
    var kIOIID = Components. interfaces. nsIIOService;
    var IOSVC = Components. classes [kIOContractID]. getService (kIOIID);
    var chan = IOSVC. newChannel (aURL, null, null);
    var listener = new this.Cb.imageLoadListener (chan);
    chan. notificationCallbacks = listener;
    listener.callBackFunction=this.setImageURL;
    chan.asyncOpen(listener, null);
  }, //}}} End Method convert_image(  )
  /**  setImageURL( url )

   Scope:   private
   Args:    url -
   Returns: Nothing
   Called:  1. convert_image method
   Purpose: 1. Insert the image data into the button image field.
  **/
  setImageURL:function ( url ) //{{{
  {
    var image_input=document.getElementById("image");
    image_input.value=url;
  }, //}}} End Method setImageURL( url )
  /**  execute_oncommand_code(  )

   Scope:   private
   Args:
   Returns: Nothing
   Called:  1. ???
   Purpose: 1. Execute the code in the code field.
  **/
  execute_oncommand_code:function ( event ) //{{{
  {
    if (window.arguments[0]){
      var button=window.arguments[0];
      var box=document.getElementById("code");
      var code=box.value;
      this.Cb.execute_oncommand_code(event,code,button);
      window.focus();
    }
    else {
      alert(this.CbStr.sEditErrorNoButton );
    }
  }, //}}} End Method execute_oncommand_code(  )
  /**  close(  )
   Scope:     private
   Args:
   Returns:   Nothing
   Called by: 1.
   Purpose:   1.
   TODO:      1.
   */
  close:function () //{{{
  {
    let lastIndex = this.Cb.aEditorWindows.length -1;
    let j = -1, i;
    for (i = 0; i <this.Cb.aEditorWindows.length;i++){
      if (this.Cb.aEditorWindows[i][0] == this.editorIndex) j = i;
    } // End for each
    // Clean up
    switch (j)
    {
    case 0:
      this.Cb.aEditorWindows.shift()
      break;
    case (lastIndex):
      this.Cb.aEditorWindows.pop();
      break;
    default :
      this.Cb.aEditorWindows = this.Cb.aEditorWindows.slice(0,j)
                                   .concat(this.Cb.aEditorWindows.slice(j+1));
      break;
    } // End switch ( this.Cb.aEditorWindows[0][0] )
    j = this.Cb.aEditorWindows.length;
    for (i = 0; i < this.Cb.aEditorWindows.length;i++){
      if (this.Cb.aEditorWindows[i][1]) j--;
    } // End for each
    if (this.Cb.aEditorWindows.length == 0 || j === 0) this.Cb.App.disableCustomize(false);
    if (this.Cb.findData[4] != -1 ) this.Cb.findData[4] = 0;
    return true;
  } //}}} End Method close(  )

}; //}}} End Object editor

